/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ConversationMessageDataError type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationMessageDataError{}

// ConversationMessageDataError struct for ConversationMessageDataError
type ConversationMessageDataError struct {
	Text *string `json:"text,omitempty"`
	Code *string `json:"code,omitempty"`
}

// NewConversationMessageDataError instantiates a new ConversationMessageDataError object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationMessageDataError() *ConversationMessageDataError {
	this := ConversationMessageDataError{}
	return &this
}

// NewConversationMessageDataErrorWithDefaults instantiates a new ConversationMessageDataError object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationMessageDataErrorWithDefaults() *ConversationMessageDataError {
	this := ConversationMessageDataError{}
	return &this
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *ConversationMessageDataError) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataError) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *ConversationMessageDataError) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *ConversationMessageDataError) SetText(v string) {
	o.Text = &v
}

// GetCode returns the Code field value if set, zero value otherwise.
func (o *ConversationMessageDataError) GetCode() string {
	if o == nil || IsNil(o.Code) {
		var ret string
		return ret
	}
	return *o.Code
}

// GetCodeOk returns a tuple with the Code field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageDataError) GetCodeOk() (*string, bool) {
	if o == nil || IsNil(o.Code) {
		return nil, false
	}
	return o.Code, true
}

// HasCode returns a boolean if a field has been set.
func (o *ConversationMessageDataError) HasCode() bool {
	if o != nil && !IsNil(o.Code) {
		return true
	}

	return false
}

// SetCode gets a reference to the given string and assigns it to the Code field.
func (o *ConversationMessageDataError) SetCode(v string) {
	o.Code = &v
}

func (o ConversationMessageDataError) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationMessageDataError) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	if !IsNil(o.Code) {
		toSerialize["code"] = o.Code
	}
	return toSerialize, nil
}

type NullableConversationMessageDataError struct {
	value *ConversationMessageDataError
	isSet bool
}

func (v NullableConversationMessageDataError) Get() *ConversationMessageDataError {
	return v.value
}

func (v *NullableConversationMessageDataError) Set(val *ConversationMessageDataError) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationMessageDataError) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationMessageDataError) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationMessageDataError(val *ConversationMessageDataError) *NullableConversationMessageDataError {
	return &NullableConversationMessageDataError{value: val, isSet: true}
}

func (v NullableConversationMessageDataError) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationMessageDataError) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


